---
title: Using the slider role
slug: Web/Accessibility/ARIA/ARIA_Techniques/Using_the_slider_role
tags:
  - ARIA
  - Accessibility
  - NeedsContent
---
<p id="Description"></p>

<p class="summary"><span class="seoSummary">This technique demonstrates how to use the <a class="external" href="http://www.w3.org/TR/wai-aria/roles#slider" rel="external" title="http://www.w3.org/TR/wai-aria/roles#slider">slider</a> role and describes the effect it has on browsers and assistive technology.</span></p>

<p>The<code> slider</code><code> </code>role is used for markup that allows a user to select a value from within a given range. The slider role is assigned to the "thumb," the control that is adjusted to change the value. As the user interacts with the thumb, the application must programmatically adjust the slider's <code>aria-valuenow</code> (and possible <code>aria-valuetext</code>) attribute to reflect the current value. See the {{ anch("Examples") }} section below for more information.</p>

<h3 id="Keyboard_And_Focus">Keyboard And Focus</h3>

<p>The slider should be keyboard focusable and operable. When the user tabs focus to the slider, it should land on the thumb: the control a mouse user would drag. Arrow keys should operate as follows (localization for right-to-left languages should reverse the direction of the arrows):</p>

<table style="width: 70%;">
 <thead>
  <tr>
   <th scope="col">Key(s)</th>
   <th scope="col">Action</th>
  </tr>
 </thead>
 <tbody>
  <tr>
   <td>Right and Up arrows</td>
   <td>Increase the selected value</td>
  </tr>
  <tr>
   <td>Left and Down arrows</td>
   <td>Decrease the selected value</td>
  </tr>
  <tr>
   <td>Page Up and Page Down</td>
   <td>Optionally increase and decrease the value by a set amount (e.g. by 10 on a range from 0 to 100)</td>
  </tr>
 </tbody>
</table>

<h2 id="Possible_effects_on_user_agents_and_assistive_technology">Possible effects on user agents and assistive technology </h2>

<div class="note"><strong>Note:</strong> Opinions may differ on how assistive technology should handle this technique. The information provided above is one of those opinions and therefore not normative.</div>

<h2 id="Examples">Examples</h2>

<h3 id="Example_1_Simple_Numerical_Range">Example 1: Simple Numerical Range</h3>

<p>In the example below, a simple slider is used to select a value between 1 and 100. The current volume is 50. The application will programmatically update the value of <code>aria-valuenow</code> in response to user input.</p>

<pre class="brush: html notranslate">&lt;label for="fader"&gt;Volume&lt;/label&gt;
&lt;input type="range"
  id="fader"
  min="1"
  max="100"
  value="50"
  step="1"
  aria-valuemin="1"
  aria-valuemax="100"
  aria-valuenow="50"
  oninput="outputUpdate(value)"&gt;
&lt;output for="fader" id="volume"&gt;50&lt;/output&gt;
</pre>

<p>The following code snippet allows you to return the output as it is updated by user input:</p>

<pre class="notranslate">function outputUpdate(vol) {
  document.querySelector('#volume').value = vol;
}
</pre>

<h3 id="Example_2_Text_Values">Example 2: Text Values</h3>

<p>Sometimes, a slider is used to choose a value that is not, semantically, a number. In these cases, the <code>aria-valuetext</code> attribute is used to provide the appropriate text name for the currently selected value. In the example below, the slider is used to select a day of the week.</p>

<pre class="brush: html notranslate">&lt;label id="day-label"&gt;Days&lt;/label&gt;
&lt;div class="day-slider"&gt;
  &lt;div id="day-handle" class="day-slider-handle" role="slider" aria-labelledby="day-label"
     aria-valuemin="1"
     aria-valuemax="7"
     aria-valuenow="2"
     aria-valuetext="Monday"&gt;
 &lt;/div&gt;
&lt;/div&gt;
</pre>

<p>The code snippet below shows a function that responds to user input and updates the <code>aria-valuenow</code> and <code>aria-valuetext</code> attributes:</p>

<pre class="brush: js notranslate">var dayNames = ["Sunday", "Monday", "Tuesday", "Wednesday", "Thursday", "Friday", "Saturday"];
var updateSlider = function (newValue) {
    var handle = document.getElementById("day-handle");
    handle<span>.setAttribute(<span class="string">"aria-valuenow"</span><span>, </span><span class="string">newValue.toString()</span><span>);</span></span>
    handle.setAttribute("aria-valuetext", dayNames[newValue]);
};
</pre>

<h2 id="Notes">Notes </h2>

<h2 id="ARIA_attributes_used">ARIA attributes used</h2>

<ul>
 <li><a href="/en/Accessibility/ARIA/ARIA_Techniques/Using_the_aria-valuemin_attribute" title="en/Accessibility/ARIA/ARIA_Techniques/Using_the_aria-valuemin_attribute">aria-valuemin</a></li>
 <li><a href="/en/Accessibility/ARIA/ARIA_Techniques/Using_the_aria-valuemax_attribute" title="en/Accessibility/ARIA/ARIA_Techniques/Using_the_aria-valuemax_attribute">aria-valuemax</a></li>
 <li><a href="/en/Accessibility/ARIA/ARIA_Techniques/Using_the_aria-valuenow_attribute" title="Using the aria-label attribute">aria-valuenow</a></li>
 <li><a href="/en/Accessibility/ARIA/ARIA_Techniques/Using_the_aria-valuetext_attribute" title="Using the aria-required attribute">aria-valuetext</a></li>
 <li><a href="/en/Accessibility/ARIA/ARIA_Techniques/Using_the_aria-orientation_attribute" title="en/Accessibility/ARIA/ARIA_Techniques/Using_the_aria-orientation_attribute">aria-orientation</a></li>
</ul>

<h2 id="Related_ARIA_techniques">Related ARIA techniques </h2>

<h2 id="Compatibility">Compatibility</h2>

<p class="comment">TBD: Add support information for common UA and AT product combinations</p>

<h2 id="Additional_resources">Additional resources</h2>

<ul>
 <li><a class="external" href="https://www.w3.org/TR/wai-aria-1.1/#slider" title="http://www.w3.org/TR/wai-aria/roles#slider">WAI-ARIA specification for the <code>slider</code> role</a></li>
</ul>
